// D import file generated from '/builddir/build/BUILD/ldc-20110901git58d40d2/druntime/src/core/demangle.d'
module core.demangle;
debug (trace)
{
    import core.stdc.stdio;
}
debug (info)
{
    import core.stdc.stdio;
}
import core.stdc.stdio;
import core.stdc.string;
import core.stdc.stdlib;
private struct Demangle
{
    enum AddType 
{
yes,
no,
}
    this(const(char)[] buf_, char[] dst_ = null)
{
this(buf_,AddType.no,dst_);
}
    this(const(char)[] buf_, AddType addType_, char[] dst_ = null)
{
buf = buf_;
addType = addType_;
dst = dst_;
}
    enum minBufSize = 4000;
    const(char)[] buf = null;
    char[] dst = null;
    size_t pos = 0;
    size_t len = 0;
    AddType addType = AddType.no;
    static class ParseException : Exception
{
    this(string msg)
{
super(msg);
}
}

    static class OverflowException : Exception
{
    this(string msg)
{
super(msg);
}
}

    static void error(string msg = "Invalid symbol");

    static void overflow(string msg = "Buffer overflow");

    static bool isAlpha(char val)
{
return 'a' <= val && 'z' >= val || 'A' <= val && 'Z' >= val;
}

    static bool isDigit(char val)
{
return '0' <= val && '9' >= val;
}

    static bool isHexDigit(char val)
{
return '0' <= val && '9' >= val || 'a' <= val && 'f' >= val || 'A' <= val && 'F' >= val;
}

    static ubyte ascii2hex(char val);

    static bool contains(const(char)[] a, const(char)[] b)
{
return a.length && b.ptr >= a.ptr && b.ptr + b.length <= a.ptr + a.length;
}

    char[] shift(const(char)[] val);
    char[] append(const(char)[] val);
    char[] put(const(char)[] val);
    void pad(const(char)[] val);
    void silent(lazy void dg);
    char tok()
{
if (pos < buf.length)
return buf[pos];
return (char).init;
}
    void test(char val)
{
if (val != tok())
error();
}
    void next()
{
if (pos++ >= buf.length)
error();
}
    void match(char val)
{
test(val);
next();
}
    void match(const(char)[] val);
    void eat(char val)
{
if (val == tok())
next();
}
    const(char)[] sliceNumber();
    size_t decodeNumber();
    void parseReal();
    void parseLName();
    char[] parseType(char[] name = null);
    void parseValue();
    void parseTemplateArgs();
    void parseTemplateInstanceName();
    bool mayBeTemplateInstanceName();
    void parseSymbolName();
    char[] parseQualifiedName();
    void parseMangledName();
    char[] opCall();
}

char[] demangle(const(char)[] buf, char[] dst = null)
{
auto d = Demangle(buf,dst);
return d();
}
string decodeDmdString(const(char)[] ln, ref int p);
